# Reverse an invoice Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Reverses a posted invoice. The reversal operation is performed asynchronously when the invoice contains more than 2,000 items in total. Restrictions You are not allowed to reverse an invoice if any of the following restrictions is met: * Payments and credit memos are applied to the invoice. * The invoice is split. * The invoice is not in Posted status. * The total amount of the invoice is less than 0 (a negative invoice). * Using Tax Connector for Extension Platform to calculate taxes. * An invoice contains more than 50,000 items in total, including invoice items, discount items, and taxation items. See Invoice Reversal for more information. Endpoint: PUT /v1/invoices/{invoiceKey}/reverse Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Path parameters: - `invoiceKey` (string, required) The ID or number of the invoice. For example, 2c92c8955bd63cc1015bd7c151af02ab or INV-0000001. ## Request fields (application/json): - `applyEffectiveDate` (string) The date when the credit memo is applied to the invoice that will be reversed, in yyyy-mm-dd format. The effective date must be later than or equal to the memo date. The default value is the date when you reverse the invoice and create the credit memo. Example: "2017-02-20" - `comment` (string) Comments about the reversal. The comment is used as the comment of the credit memo generated by reversing the specified invoice. - `memoDate` (string) The date when the credit memo was created, in yyyy-mm-dd format. The memo date must be later than or equal to the invoice date. The default value is the date when you reverse the invoice and create the credit memo. Example: "2017-02-20" - `reasonCode` (string) A code identifying the reason for the reversal. The value must be an existing reason code or empty. The code is used as the reason code of the credit memo generated by reversing the specified invoice. If you do not specify a value, Zuora uses the default reason code Invoice reversal for the credit memo. ## Response 200 fields (application/json): - `creditMemo` (object) Container for the credit memo that is automatically generated when during the invoice reversal. - `creditMemo.id` (string) The ID of the credit memo. - `debitMemo` (object) Container for the debit memo that is automatically generated during the reversal of the credit memo related to this invoice. If no related credit memo is reversed, this field is not retruned in the response body. - `debitMemo.id` (string) The ID of the debit memo. - `id` (string,null) The ID of the invoice to be reserved. This field is available only when the reversal operation is performed asynchronously. - `jobId` (string,null) The ID of the job that handles the invoice reversal operation. You can specify the value of this field as the value of the jobId path parameter in the [Retrieve an operation job](https://developer.zuora.com/v1-api-reference/api/operation/GET_OperationJob/) API operation to query job information. This field is available only when the reversal operation is performed asynchronously. - `jobStatus` (string,null) The status of the invoice reversal operation. This field is available only when the reversal operation is performed asynchronously. Enum: "Pending", "Processing", "Failed", "Completed" - `success` (boolean) Returns true if the request was processed successfully. ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.